/*
*
*
* 	Un thread tourne comme serveur ecoutant les demandes clients.
*	Pour chaque demande client il fork() et lance un thread pour le client.
*	Ce thread lance un broadcast sur son rezo et transmet le/les resultats
*	au client ?
*
*
*
*
*
*
*
*
*
*
*
*
*
*
*
*/
#include "bouncer.h"
#include "mem.h"

#include <stdio.h>
#include <sys/wait.h>
#include <signal.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>

#ifdef DEBUG
#include <time.h>
#endif
// **********************GLOBALES***************************************

Basemem * Pt_Mmem;
/*
// ***3 globales dues a l'utilisation de signaux ****

*/
// pointeur queue de file 
//P_File_Serveur Pt_QueueFile;
// pointeur sur la file 
//P_File_Serveur Pt_TeteFile;
unsigned char * Colysee;

PServerInfo SI;




#ifdef DEBUG
unsigned char GMessage[4+100+25+50+50+30+1+1+11];
char test=0;

void remplir( unsigned char *	Buf )
{

	memcpy(Buf,"C192.168.1.37:27015\0Counter-Strike 1.0 Server\0de_dust\0cstrike\0CounterStrike\0\0\6+\0",84);


}
#endif


/**********************************MAIN**************************************/
int main (int argc, char** argv) {
	PServerInfo * Server;
	int pid;
	
	if (argc <2){
		printf ("Veuillez entrer une ip en parametre\n");
		exit(-1);
	}
	// signal alarm 
	signal(SIGALRM,dumb);
	Colysee=(unsigned char *) malloc(16);
	shmid=Get_Bmem();
	Pt_Mmem=Attacher_Bmem(shmid);

	strcpy(Colysee,argv[1]);

	if ((pid=fork())==0)
	{
		printf("%s - Version %s\n",HLIT_GetCopyright(),HLIT_GetVersion());
		Server = InitUDPServer();
		if( Server == NULL ) 
		{
			printf("Erreur de creation des serveurs UDP\n");
			exit(-1);
		}
	exit(0);
	} else {
	pause();
//		sleep(2);
		printf ("%s lanc .(PIDs  %d %d %d %d )\n",HLIT_GetCopyright(),
			pid,
			Pt_Mmem->SI_HLclient_pid,
			Pt_Mmem->SI_HLserveur_pid,
			Pt_Mmem->SIT_pid);
		return 0;
	}
}/************************FIN MAIN********************************************/


/*
*
*	Demon principal ecoutant les demandes cients
*	Ouvre&bind tous les ports .
*
*/

/******************PServerInfo * InitUDPServer(int port, int portbounce)***********/
/*
*
*
*/
PServerInfo * InitUDPServer(void) 
{
	
	// pour le bouncer questionnant le serveur 
	unsigned char BLOCKING;
	pid_t pid;
	
//	Basemem Mmem;

SI = CreateServer(atoi("6999"),SOCK_DGRAM);
#ifdef DEBUG
remplir(GMessage);
printf ("Debut Initialisation\n");
#endif

//********INITIALISATIONS*************
	
	bzero(Pt_Mmem,sizeof(Basemem));
	



	BLOCKING = 0;
/*	
	Pt_Mmem->NbServeurLocal = 0;
	Pt_Mmem->NbServeurTunnel = 0;
*/	

//	Pt_TeteFile=NULL;
//	Pt_QueueFile=Pt_TeteFile;

	
#ifdef DEBUG
printf ("Debut du code\n");

#endif

//************CODE*************************
	// signal alarm 
	signal(SIGALRM,Requete_Serveur);
	// mort d'un fils 
	signal(SIGCHLD,Mort_Fils);
	// pour les signaux tueurs
	signal(SIGINT,Mort_Tunnel);
#ifdef DEBUG
	signal(SIGQUIT, Signal_Quit);
#endif	
	





	
#ifdef DEBUG
#ifdef DEBUG_SHM
// GLOBAL
printf ("shmid : %d \tshmat : %x \n",Pt_Mmem->shmid_File,(unsigned int )Pt_Mmem->File);
#endif
printf ("Debut boucle principale\n");
#endif	



	
	// on attend l'alarme .. 
	// ecouter les clients et agir ....

if((pid=fork())==0){
	signal(SIGALRM,SIG_IGN);

	Ecouter_Reponse_Serveur(Pt_Mmem);
} else {
	Pt_Mmem->SI_HLclient_pid=pid;
}

if((pid=fork())==0){
	signal(SIGALRM,SIG_IGN);
	Ecouter_Requete_Client(Pt_Mmem);
} else {
	Pt_Mmem->SI_HLserveur_pid=pid;
}

if((pid=fork())==0){
	signal(SIGALRM,SIG_IGN);
	Ecouter_Requete_Tunnel(Pt_Mmem);
} else {
	Pt_Mmem->SIT_pid=pid;
}

kill(getppid(),SIGALRM);

	// on requery toutes les minutes 
	Requete_Serveur(60);
	
do {	

sleep(1);
#ifdef DEBUG_LISTEN
printf ("InitUDPServer|NBServeur Local : %d , Tunnel : %d\n",Pt_Mmem->NbServeur,Pt_Mmem->NbServeur);
#endif	
/* pause() */
}while (1);

pause();
/*
garbagecollector();

*/
/* freeeeeeeeeaaalllllllllllllllll(Pt_TeteFile); 	OKI*/
		
}//**************FIN InitUDPServer*****************


/************************************************************************************
*
*	Le processus en lui meme
*
*/
void Repondre_Tunnel(char * RemoteHost,P_Basemem Pt_Mmem,char * port)
{
	P_File_Serveur Pt_File=NULL;
	unsigned char * Msg;
	int len;


#ifdef DEBUG_REPONSE
	int i=0;
printf ("Repondre_Tunnel|debut Pt_Mmem:%x\n",(unsigned int)Pt_Mmem);
#endif
//GLOBAL
	// on rejoint la memoire partagee de la tete de file
//	Pt_File=(Pt_Mmem->File);
	Pt_File=Attacher_File(Pt_Mmem);
//	Pt_File=Attacher_File(shmid);

#ifdef DEBUG_REPONSE
printf ("Repondre_Tunnel|shmat Pt_File : %x\n",(unsigned int) Pt_File);	
#endif
	
	while (Pt_File != NULL && (signed int)Pt_File != SHM_ERROR) 
	{

		// on rejoint le message du serveur 
		Msg = Attacher_Msg(Pt_File);
		
		
#ifdef DEBUG_REPONSE
printf ("i : %d\tPt_fil : %d\n",i++,(unsigned int) Pt_File);
printf ("Repondre_Tunnel|Msg par shmat :");fflush(stdout);
write(1,Msg,Pt_File->len);
printf ("\t len msg : %d\n",Pt_File->len);
#endif
		if (Pt_File->len>0){
			// envoie le message de ce serveur au client demandeur 
			len=UDPSendToAddr(Pt_Mmem->SIT,Msg,Pt_File->len,RemoteHost,port);
		}
		
		// on se detache du message 
		Detacher_shm( Msg );
#ifdef DEBUG_REPONSE
printf ("Repondre_Tunnel|Detacher_shm( Msg );\n");	
#endif
	
	
		if (len == SOCKET_ERROR)
			printf ("Erreur de renvoi1 len : %d\n",len);

		// on passe au serveur suivant 
		Pt_File=Cell_Suiv(Pt_File);		
#ifdef DEBUG_REPONSE
printf ("Repondre_Tunnel|Attacher_Cell_Suiv\n");	
#endif

	}
	
	
#ifdef DEBUG_REPONSE
printf ("Repondre_Tunnel|fin\n");	
#endif


}

void Repondre_Client(char * RemoteHost,P_Basemem Pt_Mmem,char * port)
{
	P_File_Serveur Pt_File=NULL;
	unsigned char * Msg;
	int len;


#ifdef DEBUG_REPONSE
	int i=0;
printf ("Repondre_Client|debut Pt_Mmem:%x\n",( unsigned int) Pt_Mmem);
#endif
	// on rejoint la memoire partagee de la tete de file
	Pt_File=Attacher_File(Pt_Mmem);


#ifdef DEBUG_REPONSE
printf ("Repondre_Client|shmat Pt_File : %x\n",(unsigned int) Pt_File);	
#endif
	
	while (Pt_File != NULL && (signed int)Pt_File != SHM_ERROR) 
	{

		// on rejoint le message du serveur 
		Msg = Attacher_Msg(Pt_File);
		
		
#ifdef DEBUG_REPONSE
printf ("i : %d\tPt_fil : %d\n",i++,(int) Pt_File);
printf ("Repondre_Client|Msg par shmat :");fflush(stdout);
write(1,Msg,Pt_File->len);
printf ("\t len msg : %d\n",Pt_File->len);
#endif
		if (Pt_File->len>0){
			// envoie le message de ce serveur au client demandeur 
			len=UDPSendToAddr(Pt_Mmem->SI_HLserveur,Msg,Pt_File->len,RemoteHost,port);
		}
		
		// on se detache du message 
		//Detacher_shm( Msg );
#ifdef DEBUG_REPONSE
printf ("Repondre_Client|Detacher_shm( Msg );\n");	
#endif
	
	
		if (len == SOCKET_ERROR)
			printf ("Erreur de renvoi1 len : %d\n",len);

		// on passe au serveur suivant 
		Pt_File=Cell_Suiv(Pt_File);		
#ifdef DEBUG_REPONSE
printf ("Repondre_Client|Attacher_Cell_Suiv\n");	
#endif

	}
	
	
#ifdef DEBUG_REPONSE
printf ("Repondre_Client|fin\n");	
#endif

	
}/*****************FIN Repondre_Client *******************/

/************************************************************************************
*
* Ecoute des reponses  des serveurs HL
*
*/
void Ecouter_Reponse_Serveur(P_Basemem Pt_Mmem)
{

	char *RemoteHost;
	unsigned char Message[65536]; 
	int len;

	// port HL normal client 
	// Ecoute les reponses des serveurs sur le port 27005
	Pt_Mmem->SI_HLclient = CreateServer(atoi(HLCLIENTPORT),SOCK_DGRAM);
	if( Pt_Mmem->SI_HLclient == NULL )
		return ;

	
#ifdef DEBUG_LISTEN
printf ("Ecouter_Reponse_Serveur|debut\n");
test=0;
#endif

	// On reinitialise a 0 le Nombre de serveurs .. 
//	 (Pt_Mmem->NbServeur)=0;
//

	do {
sleep(1);
		RemoteHost = NULL;
		len = UDPReceiveFrom(Pt_Mmem->SI_HLclient,Message,sizeof(Message),&RemoteHost,0);
#ifdef DEBUG_LISTEN
printf (" retour udpreceive host : %s len :%d\n",RemoteHost,len);
#endif
		if(len == SOCKET_ERROR)
		{
#ifdef DEBUG_LISTEN
	//pas de messages || erreur des sockets !!!
	perror("udpreceive");
	printf ("pas de messages . errno : %d \n",errno);

#endif

		} else if (len == 0)
		{
#ifdef DEBUG_LISTEN
	//erreur des sockets !!!
	printf ("Message vide : %d \n",len);

#endif			
		} else if (!strncmp(Message,REQINFO,8) || !strncmp(Message,REQPLAYERS,11))
		{ // le retour de notre braodcast info && players
#ifdef DEBUG_LISTEN
// ya pas de retour pour le client !!!
	printf("Retour du broadcast \n");
#endif			
		} else // if len < 65535
		{		
			Pt_Mmem->File=Enfiler(Pt_Mmem->File,Message,len);
			// 2 messages par serveurs ..
			// XXXXXXXXXXX
			Pt_Mmem->NbServeur++;
		}
#ifdef DEBUG_LISTEN
// ya pas de retour pour le client !!!
	printf("fin enfilage Pt_Mmem->NbServeur Local : %d , Tunnel :%d\n",(Pt_Mmem->NbServeur),Pt_Mmem->NbServeur);
#endif	

	}while (1);
//	}while (len != SOCKET_ERROR);



}


/************************************************************************************
*
*	Le demon de ecoute des clients assoifs
*
*/
void Ecouter_Requete_Client(P_Basemem Pt_Mmem)
{
	char *RemoteHost;
	unsigned char MessageDuClient[65536];	
	int lenclient;
	int pid;

	// port HL normal serveur .
	// Ecoute des requetes des clients sur le port 27015
	Pt_Mmem->SI_HLserveur = CreateServer(atoi(HLSERVERPORT),SOCK_DGRAM);
	if( Pt_Mmem->SI_HLserveur == NULL )
		return ;	
#ifdef DEBUG_LISTEN
	printf ("Ecouter_Requete_Client|Debut\n");
#endif
	do {
sleep(1);
		// on bloque == 1 tant que personne ne nous demande rien ... 
		lenclient = UDPReceiveFrom(Pt_Mmem->SI_HLserveur,MessageDuClient,sizeof(MessageDuClient),&RemoteHost,0);
		
#ifdef DEBUG_LISTEN
	printf ("Ecouter_Requete_Client|Received\n");
#endif

	// on verifie la demande 
	    if(lenclient == SOCKET_ERROR)
		{
			continue;
		}
		else if ( !strncmp(MessageDuClient,REQINFO,8) || !strncmp(MessageDuClient,REQPLAYERS,11) )
		{		
			
			
#ifdef DEBUG_LISTEN
	printf ("MessageDuClient : %s\tlen == %d\n",MessageDuClient,lenclient);
	printf ("on FORK pour un client!!\n");
#endif	
			pid=fork();

			if (pid==0)
			{
				// on lance le bouncer pour ce client 
				Repondre_Client(RemoteHost,Pt_Mmem,HLCLIENTPORT);
			
			
#ifdef DEBUG_LISTEN
	printf ("post Bouncer_Creer, freeeeee.\n");
#endif

				exit(0);
			}
		}
		else { //autre message ??
#ifdef DEBUG_LISTEN
			UDPSendBroadcast(Pt_Mmem->SI_HLserveur,GMessage,84,"27005");			
#endif
		}
		// on evite les surprises 
		bzero(MessageDuClient,2);

		// pour nettoyer les zombies..bof ... 
		waitpid(-1,NULL,WNOHANG);
		
	}while (1);	
//	}while (lenclient != SOCKET_ERROR);	
}

/************************************************************************************
*
*	Le demon de ecoute des clients pour le tunnel
*
*/
void Ecouter_Requete_Tunnel(P_Basemem Pt_Mmem)
{
	char *RemoteHost;
	unsigned char MessageDuTunnel[65536];	
	int len;
	int pid;

	// ouverture du port bouncer serveur 
	// connection tunneling
	Pt_Mmem->SIT = CreateServer(atoi(PORTBOUNCE),SOCK_DGRAM);
   	if( Pt_Mmem->SIT == NULL )
    	 return ;
	
#ifdef DEBUG_LISTEN
	printf ("Ecouter_Requete_Tunnel|Debut Pt_Mmem:%x\n",(unsigned int)Pt_Mmem);
#endif
	do {
sleep(1);
		// on bloque == 1 tant que personne ne nous demande rien ... 
		len = UDPReceiveFrom(Pt_Mmem->SIT,MessageDuTunnel,sizeof(MessageDuTunnel),&RemoteHost,0);
		
#ifdef DEBUG_LISTEN
	printf ("Ecouter_Requete_Tunnel|Received\n");
#endif

	// on verifie la demande 
	    if(len == SOCKET_ERROR)
		{
			continue;
		}
		else if ( !strncmp(MessageDuTunnel,REQINFO,8) || !strncmp(MessageDuTunnel,REQPLAYERS,11) )
		{		
			
			
#ifdef DEBUG_LISTEN
	printf ("MessageDuTunnel : %s\tlen == %d\n",MessageDuTunnel,len);
	printf ("on FORK pour un client!!\n");
#endif	
			pid=fork();

			if (pid==0)
			{
				// on lance le bouncer pour ce client 
				Repondre_Tunnel(RemoteHost,Pt_Mmem,PORTBOUNCE);
			
			
#ifdef DEBUG_LISTEN
	printf ("post Bouncer_Creer, freeeeee.\n");
#endif

				exit(0);
			}
		}
		else if (!strncmp(MessageDuTunnel,INFOSERVEUR,5) || !strncmp(MessageDuTunnel,INFOPLAYERS,5))
		{
			// on a recu des info serveurs 
			Pt_Mmem->File=Enfiler(Pt_Mmem->File,MessageDuTunnel,len);
			// 2 messages par serveurs ..
			// XXXXXXXXXXX
			Pt_Mmem->NbServeur++;
		}
		else { //autre message ??
#ifdef DEBUG_LISTEN
			UDPSendBroadcast(Pt_Mmem->SIT,GMessage,84,"27005");			
#endif
		}
		// on evite les surprises 
		bzero(MessageDuTunnel,2);

		// pour nettoyer les zombies..bof ... 
		waitpid(-1,NULL,WNOHANG);
		
	}while (1);	
//	}while (lenclient != SOCKET_ERROR);	
}






/************************************************************************************
*	Fonction de requete broadcast sur tous les serveurs HL
*
*	appele apres un SIGALRM ou si ya pas de serveur la premiere fois ..
*
*
*/

void Requete_Serveur( int sig){

	int i;	
	if (sig!=REQTIME){
		/* on rempile le SIG_ALARM */
		signal(SIGALRM,Requete_Serveur);
	}

	// il envoye une requete broadcast a tous les serveurs pour qui'ls lui repondent !! 
	i=HLI_RequestInfo(SI);
	if (i==SOCKET_ERROR)
		perror("HLI_RequestInfo");
#ifdef DEBUG_BCAST
printf ("envoie broadcast d'une Requete_Serveur : %d\n",i);
#endif

// /usr/include/asm/errno.h

	i=HLI_RequestPlayers(SI);
	if (i==SOCKET_ERROR)
		perror("HLI_RequestPlayers");
// important
//	sleep(1);
	i=HLI_RequestInfo_Unicast(SI,Colysee);
	i=HLI_RequestPlayers_Unicast(SI, Colysee);
//	Ecouter_Reponse_Serveur(Pt_Mmem->SI_HLserveur);
	alarm(60);
#ifdef DEBUG_BCAST
printf ("Sortie|requete_serveur : %d\n",(int)time(NULL));
#endif		
}

void dumb (int s)
{
	s=0;
	return;
}

/************************************************************************************
*
*	Fonction de nettoyage de zombies
*/
void Mort_Fils (int sig)
{
	// on rempile le signal 
	signal(SIGCHLD,Mort_Fils);
	
	wait(NULL);
	return;
}

void Mort_Tunnel (int sig)
{
	// on rempile le signal 
	signal(SIGINT,Mort_Tunnel);
	Pt_Mmem->NbServeur=0;
	Pt_Mmem->NbServeur=0;
	Free_Allshm(Pt_Mmem->File);
//	Signal_Quit(5);
	return;
}

void Signal_Quit ( int sig)
{
		
	P_File_Serveur PFile=Pt_Mmem->File;
	int i=0;
	signal(SIGQUIT,Signal_Quit);



	printf ("Parcours des elements : %x\n",(int)PFile);
	while (PFile!=NULL){
		i++;PFile=PFile->Prec;
		}
	printf ("Nombre serveurs en mem : %d\n",i);
	

	return;
}
