#ifndef HALFLIFE_H
#define HALFLIFE_H

#include "socks.h"
#include "global.h"


#define HL_NOTHING 	0
#define HL_INFOS	1
#define HL_PLAYERS	2

typedef struct {
   char From[100];
   char Server[25];
   char Nick[50];
   char Map[50];
   char GameType[30];
   unsigned char NbPlayers;
   unsigned char Max;
} THLInfo, *PHLInfo;

typedef struct {
   char From[100];
   unsigned char NbPlayers;
   char **Players;
   char *Frags;
} THLPlayers, *PHLPlayers;

char *HLIT_GetVersion(void);
char *HLIT_GetCopyright(void);
int HLI_RequestInfo(PServerInfo); // -1 si erreur
int HLI_RequestPlayers(PServerInfo); // -1 si erreur
int HLI_RequestInfo_Unicast(PServerInfo SI,char * Colysee);
int HLI_RequestPlayers_Unicast(PServerInfo SI,char * Colysee);
void HLI_FillInfos(char *,PHLInfo);
void HLI_FillPlayers(char *,PHLPlayers);
void *HLI_FillInformations(char *,unsigned char *,int *);
void HLI_FreeInfos(int,void *);

#endif