#include "halflife.h"
#include <stdio.h>
#include <sys/wait.h>
#include <signal.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>

#define MESSAGERECU 2

typedef struct {
  int pid;
  PServerInfo SI;
} TServer, * PServer;


PServer Server;

unsigned char Colysee[]="10.0.0.1";



PServer InitUDPServer(int port) {
   PServerInfo SI;
   int pid;
   PServer LS;
   PHLInfo HLInfo = NULL;
   PHLPlayers HLPlayers = NULL;
   int Type;
   void *temp;
	unsigned char Bool=1;



   SI = CreateServer(port,SOCK_DGRAM);

   if( SI == NULL )
     return NULL;


   pid = fork();
   if( pid == 0 ) {
      int len;
      unsigned char Message[65536];
      char *RemoteHost;
      printf("Clien listening on port %d...\n",port);
      while(Bool) {
        RemoteHost = NULL;
        len = UDPReceiveFrom(SI,Message,sizeof(Message),&RemoteHost,0);
#ifdef DEBUG
				printf ("AvAnT!!\n");
				printf ("Rien : %x\n",Bool);
#endif
		if ( Bool>MESSAGERECU && len == SOCKET_ERROR)
			Bool=0;
				if(len != SOCKET_ERROR)
				{
#ifdef DEBUG
				printf ("Reussite!!\nMessage == %s\n",Message);
				printf ("Remotehost : %s\n",RemoteHost);
				printf ("Rien : %x\tMESS : %x\n",Bool,MESSAGERECU);
#endif
//					Bool|=MESSAGERECU;
			        Message[len] = 0;
					temp = HLI_FillInformations(RemoteHost,Message,&Type);
					switch(Type)
			        {
					int i;
					case HL_NOTHING : break;
					case HL_INFOS :
						HLInfo = (PHLInfo) temp;
                        printf("INFOS\t%s\n\tIP\t%s\n\tNAME\t%s\n\tMAP\t%s\n\tTYPE\t%s\n\tPLAYERS\t%d/%d\n",HLInfo->From,HLInfo->Server,HLInfo->Nick,HLInfo->Map,HLInfo->GameType,HLInfo->NbPlayers,HLInfo->Max);
						break;
					case HL_PLAYERS :
					   HLPlayers = (PHLPlayers) temp;
					   printf("PLAYERS\t%s\n\tNAME\t\tFRAGS\n",HLPlayers->From);
					   for(i=0;i<HLPlayers->NbPlayers;i++)
					     printf("\t%s\t\t%d\n",HLPlayers->Players[i],HLPlayers->Frags[i]);
					   break;
					}
				HLI_FreeInfos(Type,temp);
				}
#ifdef DEBUG
				else {
					printf ("pErTE!!\n");
				}
#endif					

	   sleep(1);

	  }/* fin while */
   }/* fin if */
#ifdef DEBUG
printf ("allo: %s\n",Colysee);   
#endif
   LS = (PServer) malloc(sizeof(TServer));
   LS->pid = pid;
   LS->SI = SI;
   return LS;
}

void TermSigHandler(int sig)
{
   printf("Term sig detected... killing my sons...\n");
   kill(Server->pid,SIGTERM);
   printf("All done.\n");
}

int main (int argc, char** argv)
{
   int status;
   struct sigaction action;


  if (argc > 1)
  {
   strcpy(Colysee,argv[1]);
   printf("%s - Version %s\n",HLIT_GetCopyright(),HLIT_GetVersion());
	printf ("Routeur Bypassing\n");
   Server = InitUDPServer(atoi(PORTBOUNCECLIENT));
   if( Server == NULL ) {
      printf("Erreur de creation du server UDP\n");
      exit(-1);
   }
   sigemptyset(&action.sa_mask);
   action.sa_flags = 0;
   action.sa_handler = TermSigHandler;
   sigaction(SIGTERM,&action,NULL);


/* a terminer */
//	do{
	   sleep(1);
	   HLI_RequestInfo_Unicast(Server->SI,Colysee);
	   HLI_RequestPlayers_Unicast(Server->SI,Colysee);
//	 HLI_RequestInfo(Server->SI );
//	 HLI_RequestPlayers (Server->SI);

//	}while (!waitpid(Server->pid, &status,0 | WNOHANG) );


	wait(0);
	 return 0;
  }
	else{
	printf ("Veuillez entrer une ip en parametre\n");
	}
}
