/*
*
*
*	Contient la gestion de la memoire du bouncer
*
*
*
*
*
*
*
*
*
*
*
*
*
*
*
*
*
*
*
*
*/
#include "global.h"


#include "mem.h"
#include "bouncer.h"

#include <string.h>
#include <time.h>

#include <stdlib.h>
#include <stdio.h>


extern Basemem * Pt_Mmem;
/************************************************************************************
*	!!!!!!!!!!!UTILISATION DE MEMOIRE PARTAGEE!!!!!!!!!
*	Fonction d'enfilage des serveurs ..
*	Il est ou le pointeur ???
*	A ameliorer :)
*/
P_File_Serveur Enfiler( P_File_Serveur  Pt_File , unsigned char * Msg,int len )
{

	int L_shmid=0;
#ifdef DEBUG_SHM
printf ("Enfiler|debut\n");
#endif	

if (Pt_File == NULL )
	{
#ifdef DEBUG_SHM
printf ("Enfiler|(Pt_File == NULL ) L_shmid : %d\n",L_shmid);
#endif	
		/* insertion en tete */
		L_shmid = shmget(IPC_PRIVATE,sizeof(File_Serveur),DROITS);
#ifdef DEBUG_SHM
printf ("Enfiler|shmget() 1 retval :%d\n",L_shmid);
if (L_shmid==SHM_ERROR)
	perror("shmget :");
#endif
		// on se lie a la nouvelle cellule 	
		Pt_File=(P_File_Serveur) shmat (L_shmid,NULL,SHMFLAGS );

		// premiere initialisation GLOBAL
		if (Pt_Mmem->shmid_File == 0){
			(Pt_Mmem->shmid_File) = L_shmid;
			(Pt_Mmem->File) = Pt_File;
		}


#ifdef DEBUG_SHM
printf ("Enfiler|shmat() 1 retval :%x\n",Pt_File);
if (Pt_File==SHM_ERROR)
	perror("shmat :");
#endif
		// nettoyage 
		bzero((P_File_Serveur) Pt_File,sizeof(File_Serveur)); 
		
#ifdef DEBUG_SHM                                                                            
printf ("Enfiler|bzero() len : %d\n",len);                                                         
#endif
		
		// on demande de la memoire partagee pour laquelle on s'inscris 
		(Pt_File->Msg_shmid)=shmget(IPC_PRIVATE,len,DROITS);
#ifdef DEBUG_SHM
printf ("Enfiler|shmget() 2 retval :%d\n",Pt_File->Msg_shmid);
#endif
		(Pt_File->Msg)=(unsigned char *) shmat((Pt_File->Msg_shmid),NULL,SHMFLAGS );
#ifdef DEBUG_SHM
printf ("Enfiler|shmat() 2 retval :%xn",Pt_File->Msg);
#endif
		// on recopie le message ?bzero ?
		memcpy ((Pt_File->Msg),Msg,len);
#ifdef DEBUG_SHM
printf ("Enfiler|memcpy()\n");
#endif
		(Pt_File->len)=len;
		
		// on indique a quelle date on a recu la rponses de ce serveur 
		(Pt_File->Date)=time(NULL);
#ifdef DEBUG_SHM
printf ("Enfiler|milieu : date : %ld\t temps reel : %ld\n",(Pt_File->Date),(long int)time(0));
#endif			
		//enfin on fixe le shmid de la cellule
		(Pt_File->shmid)=L_shmid;
	
//Pt_QueueFile=Pt_File;
	}
	else if (Pt_File->Msg != NULL && Pt_File->Suiv != NULL)/* || Msg_shmid == 0 */
	{
#ifdef DEBUG_SHM
printf ("Enfiler|(Pt_File->Msg != NULL && Pt_File->Suiv != NULL)\n");
#endif	
		/* Cas general */
		Enfiler( Pt_File->Suiv,Msg,len);
		// on met a jour le pointeur de queue
//		Pt_QueueFile=Pt_File->Suiv;
		
	}
	else if (Pt_File->Msg != NULL && Pt_File->Suiv == NULL)
	{
#ifdef DEBUG_SHM
printf ("Enfiler|(Pt_File->Msg != NULL && Pt_File->Suiv == NULL)\n");
#endif	
		// Cas terminal 
		Pt_File->Suiv=Enfiler(NULL,Msg,len);
#ifdef DEBUG_SHM
printf ("Enfiler|retour Pt_File->Suiv:%x\n",Pt_File->Suiv);
#endif	

		// on attache la double liaison 
		if (Pt_File->Suiv == NULL )
			return (P_File_Serveur)SHM_ERROR;
		
		
		// on attache la double liaison 
		(Pt_File->Suiv->Prec_shmid)=(Pt_File->shmid);
		(Pt_File->Suiv->Prec)=Pt_File;
		(Pt_File->Suiv_shmid)=(Pt_File->Suiv->shmid);
		
	}
	else /*if ((Pt_File->Msg) == NULL )*/
	{
#ifdef DEBUG_SHM
printf ("Enfiler|else\n");
#endif	
	printf ("YA UNE COUILLE\n");
	}
	
	return Pt_File;
}

/**********************************************************************************************
*
*	Se rattache a la cellule suivante de la file et de dtache de la cellule precedente
*	Entree/Sortie : Pointeur vers la cellule dtache/attache
*
*/
P_File_Serveur Cell_Suiv(P_File_Serveur Pt_File)
{
	P_File_Serveur Pt_File_Suiv;
	int L_shmid=(Pt_File->Suiv_shmid);
	
	// on se detache de la cellule deja vue 
	shmdt(Pt_File);
	
	if (L_shmid==0)
		return SHM_ERROR;
	
	// on rejoint la memoire partagee de la cellule suivante
	Pt_File_Suiv=(P_File_Serveur) shmat ( L_shmid,NULL,SHMFLAGS );

	// on renvoie la nouvelle adresse 
	return Pt_File_Suiv;

//	return Pt_File->Suiv;
}

/**********************************************************************************************
*
*	Se rattache a la tete la file designe par shmid
*	Retourne : Pointeur vers la tet de file
*
*/
/*
P_File_Serveur Attacher_FileTunnel(P_Basemem Pt_Mmem) 
{
	// on rejoint la memoire partagee de la tete de file
	P_File_Serveur L_Pt=(P_File_Serveur) shmat ( Pt_Mmem->shmid_FileTunnel,NULL,SHMFLAGS );
	if (L_Pt==SHM_ERROR){
		perror("Shmat Attacher_File");
	}
	return Pt_Mmem->FileTunnel=L_Pt;

//	return (Pt_Mmem->File);
}
*/
/**********************************************************************************************
*
*	Se rattache a la tete la file designe par shmid
*	Retourne : Pointeur vers la tet de file
*
*/
P_File_Serveur Attacher_File(P_Basemem Pt_Mmem) 
{
	// on rejoint la memoire partagee de la tete de file
	P_File_Serveur L_Pt=(P_File_Serveur) shmat ( Pt_Mmem->shmid_File,NULL,SHMFLAGS );
	if (L_Pt==(SHM_ERROR)){
		perror("Shmat Attacher_File");
	}
	return L_Pt;

//	return (Pt_Mmem->File);
}

/**********************************************************************************************
*
*	Se rattache au message du serveur de la cellule pointe par Pt_File
*	Retourne : Pointeur vers le Message 
*
*/
unsigned char * Attacher_Msg(P_File_Serveur Pt_File)
{
	// on rejoint le message du serveur design par Pt_File 
	unsigned char *L_Pt=( unsigned char * ) shmat ((Pt_File->Msg_shmid),NULL,SHMFLAGS);
//	unsigned char *L_Pt=( unsigned char * )(Pt_File->Msg);
	if (L_Pt==SHM_ERROR){
		perror("Shmat Attacher_Msg");
	}
	return L_Pt;

}

/**********************************************************************************************
*
*	Se detache d'une zone memoire partage point par Pt
*	Un message par exemple ...
*/
int Detacher_shm(unsigned char * Pt )
{
// dumb .. exit se detache pour nous
	// on detache ... 
	int i= shmdt(Pt);
	if (i==SHM_ERROR){
		perror("Shmdt Detacher_shm");
	}
	return i;

//	return 0;
}

/**********************************************************************************************
*
*	on se detache de *toute* la Shared memory concernant
*	la structure actuelle
*/
void Free_Allshm(P_File_Serveur Pt_Tete_File){
	P_File_Serveur PFile=Pt_Tete_File;	
	int i=0;
	static int j;
#ifdef DEBUG_SHM
printf ("Let's smash the Shared system\n");
#endif
	if (PFile==NULL){
		j=0;
		return;
	}

	Free_Allshm(PFile->Suiv);
	printf ("1-----\n");

printf ("GOGOGO-\n");
	// on marque le segment comem pret a etre detruit
	shmctl(PFile->Msg_shmid, IPC_RMID,NULL);
#ifdef DEBUG_SHM
printf ("Free_Allshm|shmctl()Msg : %d\n",i);
#endif		
	i=shmctl(PFile->shmid, IPC_RMID,NULL);
#ifdef DEBUG_SHM
printf ("Free_Allshm|shmctl() : %d\n",i);
#endif	

	if (PFile->Msg!=NULL){
		i= shmdt(PFile->Msg);	
		printf ("b-----%d\n",i);
	}	
	printf ("2-----\n");

	i= shmdt(PFile);
	printf ("a-----%d\n",i);

	j++;


#ifdef DEBUG_SHM

printf ("Yeeahhh the Shared system was crushed %d times \n",j);
#endif	
	return;
}

/**********************************************************************************************
*
*	Obtenir l'espace memoire de base 
*	Retourne : le shmid
*
*/
int Get_Bmem() 
{
	int monshmid;
	// on Obtient la memoire de base
	monshmid=shmget(IPC_PRIVATE,sizeof(Basemem),DROITS);
	if (monshmid==SHM_ERROR){
		perror("Get_Bmem");
	}
	return monshmid;
}

/**********************************************************************************************
*
*	Se rattache a la memoire de base designe par shmid
*	Retourne : Pointeur vers la Bmem
*
*/
P_Basemem Attacher_Bmem(int monshmid) 
{
	// on rejoint la memoire de base
	P_Basemem Pt=(P_Basemem) shmat ( monshmid,NULL,SHMFLAGS );
	if ((int)Pt==SHM_ERROR){
		perror("Shmat Attacher_Bmem");
	}
	return Pt;
}
